local assets = require('assets')
local const = require('const')
local GameState = require('GameState')
local Animation = require('Animation')

local mt = {}
mt.__index = mt

_G.points = 0

function love.load()
end

function love.update(dt)
  if self.is_dead then
  end
end

function mt:draw()
  if self.is_dead then
  end

  if self.visible then
    assets.qdraw(self.current_anim:getFrame(), self.x + 16, self.y, 0, -1, 1)
  else 
    assets.qdraw(43, self.x, self.y)
  end
end

function mt:update(dt)
  self.current_anim:update(dt)
end

function mt:setAnim(name)
  self.current_anim = self.anims[name]
end

function mt:onTouch(other)
  if other.is_hero then
    if not self.is_dead then
      self.is_dead = true
      self.is_touchable = false
      self.is_stompable = false
	    self.visible = false
	    points = points + 1
    end
  end
end

function mt:onStomp()
  if not self.is_dead then
    self.is_touchable = false
    self.is_stompable = false
    self.is_dead = true
	self.visible = false
    points = points + 1
  end
end

return {
  new = function(x, y)
    local e = setmetatable({
      is_touchable = true,
      is_stompable = true,
      is_dead = false,
      visible = true,
      x = x,
      y = y,
      w = const.tilesize,
      h = const.tilesize,
      anims = {
        idle = Animation.new(39, 3, 0.8),
      }
    }, mt)
		
	e:setAnim('idle')
    return e

  end,
  getPoints = function()
    return points
  end
}
