local GameState = require('GameState')
local main = require('main')
local Hero = require('Hero')

local playing = false

_G.deaths = -1
_G.hx = 0
_G.hy = 0

-- for blinking
local time = 0
local interval = 0.6  -- Interval in seconds
local con = false

local mt = {}
mt.__index = mt

function mt:update(dt)
  time = time + dt
  if time >= interval then
    con = not con  -- Toggle the boolean value
    time = 0  -- Reset the timer
  end
  if main.deaths then
	  _G.deaths = main.deaths
  end
  if Hero.hx then
	  _G.hx = Hero.hx
  end
  if Hero.hy then
    _G.hy = Hero.hy
  end
  
  if love.keyboard.isDown('return') then
    GameState.setCurrent('Play', 1)
	  playing = true
	  _G.deaths = _G.deaths + 1
  end
end

function mt:draw()
  love.graphics.setColor(1,1,1)
  if not playing then
    love.graphics.printf("LOST", 75, 375, 1000, "left", 0, 1.5, 1.5)
    if con then
      love.graphics.printf("Press Enter To Continue", -10, 455, 1000, "left", 0, 1.5, 1.5)
      else
      love.graphics.printf("", 0, 180, 1000, "left", 0, 1, 1)
    end
  else
    love.graphics.printf("You Died", _G.hx + 35, _G.hy - 20, 1000, "left", 0, 1.5, 1.5)
    if con then
      love.graphics.printf("Press Enter To Play Again", _G.hx - 35, _G.hy + 50, 1000, "left", 0, 1.5, 1.5)
    end
  end
end

function mt:trigger()
end

return {
  new = function()
    return setmetatable({ name = 'dead_state' }, mt)
  end
}
