local const = require('const')

local mt = {}
mt.__index = mt

function mt:draw()
  for i, tile in pairs(self.tiles) do
    love.graphics.rectangle('line', tile.x, tile.y, tile.w, tile.h)
  end
end

local TILES_TYPES = {
  [21] = require('Hero'),
  [6] = require('Tile'),
  [7] = require('tileTopRight'),
  [5] = require('tileTopLeft'),
  [9] = require('tileBotRight'),
  [8] = require('tileBotLeft'),
  [16] = require('ToggleFloor'),
  [1] = require('Door'),
  [13] = require('Spikes'),
  [18] = require('SpikesL'),
  [19] = require('SpikesR'),
  [17] = require('SpikesUp'),
  [14] = require('Lever'),
  [33] = require('Enemy'),
  [39] = require('Coin'),
  [32] = require('Saw'),
}

return {
  new = function(lvl_name, game_state )
    local lvl = setmetatable({ columns = 323, tiles = {} }, mt)

    lvl.data = require(lvl_name)

    for i, v in ipairs(lvl.data) do
      local x, y = (i-1) % lvl.columns * const.tilesize, math.floor((i-1) / lvl.columns) * const.tilesize
      if TILES_TYPES[v] then
        game_state.world:add( TILES_TYPES[v].new(x, y, game_state) )
      end
    end

    return lvl
  end
}
