local GameState = require('GameState')
local Level = require('Level')
local World = require('World')

local MAX_LEVEL = 1

local dp = 9.3
local play = false

-- intro --
local dcre = 3.3  -- Delay in seconds
local dlogo = 3.5
local elapsed = 0
local discre = true
local logo = false
local crea = 1

-- for blinking
local time = 0
local interval = 0.6  -- Interval in seconds
local con = false

-- story --
local d1 = 5.3  -- Delay in seconds
local d2 = 6.3
local d3 = 7.3
local dd = 8
local _do = 9
local dc = 9.2
local elapseds = 0
local print1 = false
local print2 = false
local print3 = false
local dead = false

local conS = false

local mt = {}
mt.__index = mt

function mt:update(dt)
  elapsed = elapsed + dt

  -- Check if the delay has passed
  if elapsed >= dcre and discre then
    discre = false
  end

  if not discre then
    crea = crea - 0.025
  end
  
  if elapsed >= dlogo and not logo then
    logo = true
  end
  
  if logo then
    time = time + dt
  end
  
  if time >= interval then
    con = not con  -- Toggle the boolean value
    time = 0  -- Reset the timer
  end

  -- story --
  elapseds = elapseds + dt
  
  if elapseds >= d1 and elapseds < 9.2 then
    print1 = true
  elseif elapseds >= 9.2 then
    print1 = false
  end
  
  if elapseds >= d2 and elapseds < 9.2 then
    print2 = true
  elseif elapseds >= 9.2 then
    print2 = false
  end
  
  if elapseds >= d3 and elapseds < 9.2 then
    print3 = true
  elseif elapseds >= 9.2 then
    print3 = false
  end
  
  if elapseds >= dc and not conS then
    conS = true
  end
  
  -- menu
  if elapsed >= dd and elapsed <= _do and not dead then
    dead = true
  end

  if dead then
    GameState.setCurrent('Dead')
    dead = false
  end

  -- play --
  -- Check if the delay has passed
  if elapsed >= dp and not play then
    play = true
  end

  for i, item in ipairs(self.world.items) do
    if item.update then
      item:update(dt, self.world)
    end
  end

  if self.close_t then
    self.close_t = self.close_t - dt
    if self.close_t < 0 and play then
	    GameState.setCurrent('Dead')
    end
  end
end

function mt:draw()
  -- Info text
  love.graphics.setColor(1,1,1,crea)
  love.graphics.printf("Created By\n   GhosX", 58, 385, 1000, "left", 0, 1.25, 1.25)
  love.graphics.setColor(1,1,1,1)

  --story--
  if print1 then
    love.graphics.printf("An Ordinary Boy", -20, 345, 1200, "left", 0, 1.5, 1.5)
  end
  
  if print2 then
    love.graphics.printf("Lost in Another...", -20, 345 + 50, 1200, "left", 0, 1.5, 1.5)
  end
  
  if print3 then
    love.graphics.setColor(1, 0.1, 0.1)
    love.graphics.printf("Dimension", -20, 345 + 100, 1200, "left", 0, 1.5, 1.5)
	  love.graphics.setColor(1, 1, 1)  -- Reset color to white
  end
  
  -- draw the map --

  for _, item in ipairs(self.world.items) do
    if play then
      item:draw()
    end
  end
end

function mt:trigger(event, actor, data)
  if event == 'hero:kill' then
    local hero = data
    hero.is_disabled = true
    self.close_t = (self.close_t or 1)

  elseif event == 'hero:action' then
    local actables = self.world:find(actor, 'is_actable')

    if actables[1] then
      actables[1]:onHeroAction()
    end

  elseif event == 'door:open' then
    if self.level_num < MAX_LEVEL then
      GameState.setCurrent('Play', self.level_num + 1)
    else
      GameState.setCurrent('Win')
    end
  end
end

return {
  new = function(level_num)
    local state = setmetatable({ name = 'play_state' }, mt)

    state.world = World.new()
    state.level = Level.new('map_' .. level_num, state)
    state.level_num = level_num

    return state
  end
}
