local GameState = require('GameState')
local Hero = require('Hero')

local mt = {}
mt.__index = mt

_G.hx = 0
_G.hy = 0

local bga = 1

local d1 = 1
local d2 = 2
local d3 = 3
local d4 = 7.3
local elapseds = 0
local print1 = false
local print2 = false
local print3 = false
local print4 = false

function mt:update(dt)
  bga = bga - 0.01

  elapseds = elapseds + dt

  if elapseds >= d1 and elapseds < 6.5 then
    print1 = true
  elseif elapseds >= 6.5 then
    print1 = false
  end

  if elapseds >= d2 and elapseds < 6.5 then
    print2 = true
  elseif elapseds >= 6.5 then
    print2 = false
  end

  if elapseds >= d3 and elapseds < 6.5 then
    print3 = true
  elseif elapseds >= 6.5 then
    print3 = false
  end

  if Hero.hx then
	  _G.hx = Hero.hx
  end
  if Hero.hy then
    _G.hy = Hero.hy
  end

  if elapseds >= d4 and elapseds < 11.3 then
    print4 = true
  elseif elapseds >= 11.3 then
    if love.keyboard.isDown('a') then
      love.event.quit('restart')
    elseif love.keyboard.isDown('s') then
      love.event.quit()
    end
  end
end

function mt:draw()
  love.graphics.setColor(0,0,0,bga)
  love.graphics.rectangle("fill",-500,-500,love.graphics.getWidth()+1000,love.graphics.getHeight()+1000)
  love.graphics.setColor(1,1,1,1)

  if print1 then
      love.graphics.printf("The Ordinary Boy", _G.hx - 75, _G.hy - 50, 1200, "left", 0, 1.5, 1.5)
  end
    
  if print2 then
    love.graphics.printf("Has Returned...", _G.hx - 75, _G.hy, 1200, "left", 0, 1.5, 1.5)
  end
  
  if print3 then
    love.graphics.setColor(0.8, 0.8, 0.8)
    love.graphics.printf("HOME", _G.hx - 75, _G.hy + 50, 1200, "left", 0, 1.5, 1.5)
    love.graphics.setColor(1, 1, 1)
  end

  if print4 then
    love.graphics.printf("           THE END\n\n\n   Press A To Play Again\n\nPress S To Quit The Game", _G.hx - 35, _G.hy - 50, 1200, "left", 0, 1.5, 1.5)
  end
end

function mt:trigger()
end

return {
  new = function()
    return setmetatable({ name = 'win_state' }, mt)
  end
}
